﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Configuration;
using System.Text;

namespace WebApplication1 {
    public partial class Upload : System.Web.UI.Page {
        protected void Page_Load(object sender, EventArgs e) {
            string jobID = "";
            if (Request.Files.Count > 0) {
                string settingsName = Request.Form["cmbSettings"];
                jobID = ProcessPostedFile(Request.Files[0], settingsName);
            }

            string responseUrl = "AutoOCRDemo.htm?jobid=" + jobID;
            Response.Redirect(responseUrl);
        }
        protected string ProcessPostedFile(HttpPostedFile postedFile, string settingsName) {
            try {
                string ext = System.IO.Path.GetExtension(postedFile.FileName).TrimStart('.');
                byte[] fileData = new byte[postedFile.ContentLength];
                postedFile.InputStream.Read(fileData, 0, fileData.Length);

                

                string url = ConfigurationManager.AppSettings["AutoOCRBaseUrl"] + "UploadJobEx?ext=" + ext + "&settingsName=" + settingsName;
                WebClient client = new WebClient();
                client.Headers.Add(HttpRequestHeader.ContentType, "file/ext");
                //client.Headers.Add(HttpRequestHeader.ContentLength, fileData.Length.ToString());
                byte[] responseData = client.UploadData(url, "PUT", fileData);

                System.Xml.XmlDocument doc = new System.Xml.XmlDocument();
                doc.LoadXml(Encoding.ASCII.GetString(responseData));
                if (doc.DocumentElement.Name == "UploadJobExResponse") {

                    return doc.GetElementsByTagName("a:JobGuid")[0].InnerText;
                    //return doc.DocumentElement.InnerText;
                }
                return "";
            }
            catch {
                return "";
            }
        }
        
    }

}
