﻿var AutoOCRJSON = {
    baseUrl: "",
    jobID: "",
    statusEvent: function(status) { },
    getNrOfPagesEvent: function(nrofpages) { },
    resultCountEvent: function(resultCount) { },
    resultExtEvent: function(resultExt) { },
    resultEvent: function(resultData) { },
    uploadedEvent: function(jobID) { },
    settingsCollectionEvent: function(settings) { },
    availablePagesEvent: function(availablePages) { },
    getNrOfPagesInQueueEvent: function(nrOfPages) { },
    getNrOfDocumentsInQueueEvent: function(nrOfDocuments) { },
    getAvgSecPerPageEvent: function(avgSecPerPage) { },
    authEvent: function(result) { },
    onFail: function() { },


    onGetStatus: function(text, xml) {
        var status = JSON.parse(text).GetStatusResult;
        if (AutoOCRJSON.statusEvent) AutoOCRJSON.statusEvent(status);
    },
    onGetResultCount: function(text, xml) {
        var resultCount = JSON.parse(text).GetResultCountResult;
        if (AutoOCRJSON.resultCountEvent) AutoOCRJSON.resultCountEvent(resultCount);
    },
    onGetResultExt: function(text, xml) {
        var resultExt = JSON.parse(text).GetResultExtResult;
        if (AutoOCRJSON.resultExtEvent) AutoOCRJSON.resultExtEvent(resultExt);
    },
    onGetResult: function(text, xml) {
        var result = JSON.parse(text).GetResultResult;
        if (AutoOCRJSON.resultEvent) AutoOCRJSON.resultEvent(result);
    },
    onRemoveJob: function(text, xml) {

    },
    onGetSettingsCollection: function(text, xml) {
        var result = JSON.parse(text).GetSettingsCollectionResult;
        if (AutoOCRJSON.settingsCollectionEvent) {
            AutoOCRJSON.settingsCollectionEvent(result);
        }
    },
    onGetResultFromServer: function(text, xml) {
        var result = JSON.parse(text);
        if (result.GetAvailablePagesResult != undefined) {
            if (AutoOCRJSON.availablePagesEvent) {
                AutoOCRJSON.availablePagesEvent(result.GetAvailablePagesResult);
            }
        }
        else if (result.GetNrOfPagesInQueueResult != undefined) {
            if (AutoOCRJSON.getNrOfPagesInQueueEvent) {
                AutoOCRJSON.getNrOfPagesInQueueEvent(result.GetNrOfPagesInQueueResult);
            }
        }
        else if (result.GetNrOfDocumentsInQueueResult != undefined) {
            if (AutoOCRJSON.getNrOfDocumentsInQueueEvent) {
                AutoOCRJSON.getNrOfDocumentsInQueueEvent(result.GetNrOfDocumentsInQueueResult);
            }
        }
        else if (result.GetAvgSecPerPageResult != undefined) {
            if (AutoOCRJSON.getAvgSecPerPageEvent) {
                AutoOCRJSON.getAvgSecPerPageEvent(result.GetAvgSecPerPageResult);
            }
        }
        else if (result.GetNrOfPagesResult != undefined) {
            if (AutoOCRJSON.getAvgSecPerPageEvent) {
                AutoOCRJSON.getAvgSecPerPageEvent(result.GetNumberOfPagesResult);
            }
        }
        else if (result.AuthResult != undefined) {
            if (AutoOCRJSON.authEvent)
                AutoOCRJSON.authEvent(result.AuthResult);
        }


    },

    getNrOfPages: function() {
        if (AutoOCRJSON.jobID == "") return;
        var url = this.baseUrl + "/GetNrOfPages?jobID=" + AutoOCRJSON.jobID;
        xhr.doGet(url, "", AutoOCRJSON.onGetResultFromServer, AutoOCRJSON.onFail);
    },
    getStatus: function() {
        if (AutoOCRJSON.jobID == "") return;
        var url = this.baseUrl + "/GetStatus?jobID=" + AutoOCRJSON.jobID.toString();
        xhr.doGet(url, "", AutoOCRJSON.onGetStatus, AutoOCRJSON.onFail);
    },
    getResultCount: function() {
        if (AutoOCRJSON.jobID == "") return;
        var url = AutoOCRJSON.baseUrl + "/GetResultCount?jobID=" + AutoOCRJSON.jobID.toString();
        xhr.doGet(url, "", AutoOCRJSON.onGetResultCount, AutoOCRJSON.onFail);
    },
    getResultExt: function(index) {
        if (AutoOCRJSON.jobID == "") return;
        var url = AutoOCRJSON.baseUrl + "/GetResultExt?jobID=" + AutoOCRJSON.jobID.toString() + "&index=" + index.toString();
        xhr.doGet(url, "", AutoOCRJSON.onGetResultExt, this.onFail);
    },
    getResult: function(index, removeFile) {
    if (AutoOCRJSON.jobID == "") return;
        var url = AutoOCRJSON.baseUrl + "/GetResult?jobID=" + AutoOCRJSON.jobID.toString() + "&index=" + index.toString() + "&removeFiles=" + (removeFile ? "True" : "False");
        xhr.doGet(url, "", AutoOCRJSON.onGetResult, AutoOCRJSON.onFail);
    },
    removeJob: function() {
        if (AutoOCRJSON.jobID == "") return;
        var url = this.baseUrl + "/RemoveJob?jobID=" + AutoOCRJSON.jobID.toString();
        xhr.doGet(url, "", AutoOCRJSON.onRemoveJob, this.onFail);
    },
    getSettingsCollection: function() {
        var url = this.baseUrl + "/GetSettingsCollection";
        xhr.doGet(url, "", AutoOCRJSON.onGetSettingsCollection, this.onFail);
    },
    getAvailablePages: function() {
        var url = this.baseUrl + "/GetAvailablePages";
        xhr.doGet(url, "", AutoOCRJSON.onGetResultFromServer, this.onFail);
    },
    getNrOfPagesInQueue: function() {
        var url = this.baseUrl + "/GetNrOfPagesInQueue";
        xhr.doGet(url, "", AutoOCRJSON.onGetResultFromServer, this.onFail);
    },
    getNrOfDocumentsInQueue: function() {
        var url = this.baseUrl + "/GetNrOfDocumentsInQueue";
        xhr.doGet(url, "", AutoOCRJSON.onGetResultFromServer, this.onFail);
    },
    getAvgSecPerPage: function() {
        var url = this.baseUrl + "/GetAvgSecPerPage";
        xhr.doGet(url, "", AutoOCRJSON.onGetResultFromServer, this.onFail);
    },
    auth: function(user, password) {
        var url = this.baseUrl + "/Auth?userName=" + user + "&password=" + password;
        xhr.doGet(url, "", AutoOCRJSON.onGetResultFromServer, this.onFail);
    }

}